Delete a Compute Engine instance

This document explains how to permanently delete a Compute Engine instance.

If you no longer need a compute instance, then delete it to stop incurring charges for the compute instance and its attached resources. You can't recover the deleted compute instance. To learn more about the states that a compute instance goes through from its creation up to its deletion, see Compute Engine instance lifecycle.

Billing implications for deleted instances

After you delete a compute instance, you stop incurring charges for the compute instance and its attached resources, except in the following cases:

  • If you delete a compute instance that is hosted on a sole-tenant node, then you still incur charges for the sole-tenant node.

  • If you delete a compute instance that you created by using a reservation, then you continue to pay for the reserved resources until one of the following occurs:

    • You delete the reservation, or Compute Engine does so for an automatic operation.

    • You reduce the number of reserved compute instances in the reservation.

  • If you have a committed use discount, then you continue to pay for the committed resources, regardless if you use them or not.

  • If you preserve any resources that are attached to the compute instance, such as disks or external IP addresses, then you continue to pay for those resources until you delete them.

For more information, see VM instances pricing.

Before you begin

Preserve attached resources

If you want to preserve a resource that is attached to a compute instance before you delete it, then you can do one or more of the following:

Required roles

To get the permissions that you need to delete a compute instance, ask your administrator to grant you the Compute Instance Admin (v1) (roles/compute.instanceAdmin.v1) IAM role on the project. For more information about granting roles, see Manage access to projects, folders, and organizations.

This predefined role contains the permissions required to delete a compute instance. To see the exact permissions that are required, expand the Required permissions section:

Required permissions

The following permissions are required to delete a compute instance:

  • compute.instances.delete on the compute instance
  • To force the deletion of an attached disk: compute.disks.delete on the disk

You might also be able to get these permissions with custom roles or other predefined roles.

Delete compute instances

When you delete a compute instance, Compute Engine stops the compute instance before it's deleted. If you delete one or more compute instances simultaneously, then you must decide what happens to the attached disks:

  • Delete disks: you can delete the boot disks, non-boot disks, or all of its attached disks to your compute instances. If you configured your disks to be preserved upon deletion, then you can optionally override this configuration and force their deletion.

    For instructions, see Delete compute instances and all attached resources.

  • Preserve disks: you can preserve boot disks, non-boot disks, or all of its attached disks to your compute instances.

    For instructions, see Delete compute instances and preserve disks.

Delete compute instances and all attached resources

To delete compute instances in specific scenarios—such as forcing the deletion of attached disks, skipping or ending a graceful shutdown, or deleting multiple instances at the same time—use the appropriate method:

  • Force delete disks: if you've configured an attached disk to be preserved when Compute Engine deletes a compute instance, then you can override this setting and force its deletion by using the Google Cloud CLI.

  • Skip or end a graceful shutdown: if you've enabled graceful shutdown in the compute instance, then you can delete the compute instance without gracefully shutting it down or end an ongoing graceful shutdown by using the Google Cloud console, gcloud CLI, or REST API.

  • Delete multiple compute instances: if you want to delete multiple compute instances simultaneously, then use the Google Cloud console or, for multiple compute instances that exist in the same zone, the gcloud CLI.

To delete one or more compute instances and all of their attached resources, select one of the following options:

Console

  1. In the Google Cloud console, go to the VM instances page.

    Go to VM instances

  2. Select the instances that you want to delete.

  3. Click Delete. If there is no Delete option, then click More actions, and then select Delete.

  4. In the dialog that appears, do the following:

    1. Optional: To delete the compute instances without gracefully shutting them down, or to end an ongoing graceful shutdown, select the Skip graceful shutdown (if applicable) checkbox.

    2. To confirm, click Delete.

gcloud

To delete one or more compute instances in the same zone, use the gcloud compute instances delete command:

gcloud compute instances delete INSTANCE_NAMES \
    --zone=ZONE

Replace the following:

  • INSTANCE_NAMES: a list of names of compute instances that you want to delete, separated by spaces. For example, specify instance-01 instance-02 instance-03.

  • ZONE: the zone where the compute instances exist.

Optionally, you can include one or both of the following flags:

  • To force the deletion of the disks that are attached to one or more compute instances, include the --delete-disks flag:

    gcloud compute instances delete INSTANCE_NAMES \
        --delete-disks=DELETE_DISK_TYPE \
        --zone=ZONE
    

    Replace DELETE_DISK_TYPE with the types of storage that you want to delete. Specify one of the following values:

    • To delete boot and non-boot persistent storage: all

    • To delete only boot persistent storage: boot

    • To delete only non-boot persistent storage: data

  • To skip or end an ongoing graceful shutdown, include the --no-graceful-shutdown flag:

    gcloud compute instances delete INSTANCE_NAMES \
        --no-graceful-shutdown \
        --zone=ZONE
    

C#


using Google.Cloud.Compute.V1;
using System.Threading.Tasks;

public class DeleteInstanceAsyncSample
{
    public async Task DeleteInstanceAsync(
        // TODO(developer): Set your own default values for these parameters or pass different values when calling this method.
        string projectId = "your-project-id",
        string zone = "us-central1-a",
        string machineName = "test-machine")
    {

        // Initialize client that will be used to send requests. This client only needs to be created
        // once, and can be reused for multiple requests.
        InstancesClient client = await InstancesClient.CreateAsync();

        // Make the request to delete a VM instance.
        var instanceDeletion = await client.DeleteAsync(projectId, zone, machineName);

        // Wait for the operation to complete using client-side polling.
        await instanceDeletion.PollUntilCompletedAsync();
    }
}

Go

import (
	"context"
	"fmt"
	"io"

	compute "cloud.google.com/go/compute/apiv1"
	computepb "cloud.google.com/go/compute/apiv1/computepb"
)

// deleteInstance sends a delete request to the Compute Engine API and waits for it to complete.
func deleteInstance(w io.Writer, projectID, zone, instanceName string) error {
	// projectID := "your_project_id"
	// zone := "europe-central2-b"
	// instanceName := "your_instance_name"
	ctx := context.Background()
	instancesClient, err := compute.NewInstancesRESTClient(ctx)
	if err != nil {
		return fmt.Errorf("NewInstancesRESTClient: %w", err)
	}
	defer instancesClient.Close()

	req := &computepb.DeleteInstanceRequest{
		Project:  projectID,
		Zone:     zone,
		Instance: instanceName,
	}

	op, err := instancesClient.Delete(ctx, req)
	if err != nil {
		return fmt.Errorf("unable to delete instance: %w", err)
	}

	if err = op.Wait(ctx); err != nil {
		return fmt.Errorf("unable to wait for the operation: %w", err)
	}

	fmt.Fprintf(w, "Instance deleted\n")

	return nil
}

Java


import com.google.api.gax.longrunning.OperationFuture;
import com.google.cloud.compute.v1.DeleteInstanceRequest;
import com.google.cloud.compute.v1.InstancesClient;
import com.google.cloud.compute.v1.Operation;
import java.io.IOException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

public class DeleteInstance {

  public static void main(String[] args)
      throws IOException, InterruptedException, ExecutionException, TimeoutException {
    // TODO(developer): Replace these variables before running the sample.
    String project = "your-project-id";
    String zone = "zone-name";
    String instanceName = "instance-name";
    deleteInstance(project, zone, instanceName);
  }

  // Delete the instance specified by `instanceName`
  // if it's present in the given project and zone.
  public static void deleteInstance(String project, String zone, String instanceName)
      throws IOException, InterruptedException, ExecutionException, TimeoutException {
    // Initialize client that will be used to send requests. This client only needs to be created
    // once, and can be reused for multiple requests. After completing all of your requests, call
    // the `instancesClient.close()` method on the client to safely
    // clean up any remaining background resources.
    try (InstancesClient instancesClient = InstancesClient.create()) {

      System.out.printf("Deleting instance: %s ", instanceName);

      // Describe which instance is to be deleted.
      DeleteInstanceRequest deleteInstanceRequest = DeleteInstanceRequest.newBuilder()
          .setProject(project)
          .setZone(zone)
          .setInstance(instanceName).build();

      OperationFuture<Operation, Operation> operation = instancesClient.deleteAsync(
          deleteInstanceRequest);
      // Wait for the operation to complete.
      Operation response = operation.get(3, TimeUnit.MINUTES);

      if (response.hasError()) {
        System.out.println("Instance deletion failed ! ! " + response);
        return;
      }
      System.out.println("Operation Status: " + response.getStatus());
    }
  }
}

Node.js

/**
 * TODO(developer): Uncomment these variables before running the sample.
 */
// const projectId = 'YOUR_PROJECT_ID';
// const zone = 'europe-central2-b'
// const instanceName = 'YOUR_INSTANCE_NAME';

const compute = require('@google-cloud/compute');

// Delete the instance specified by `instanceName` if it's present in the given project and zone.
async function deleteInstance() {
  const instancesClient = new compute.InstancesClient();

  console.log(`Deleting ${instanceName} from ${zone}...`);

  const [response] = await instancesClient.delete({
    project: projectId,
    zone,
    instance: instanceName,
  });
  let operation = response.latestResponse;
  const operationsClient = new compute.ZoneOperationsClient();

  // Wait for the delete operation to complete.
  while (operation.status !== 'DONE') {
    [operation] = await operationsClient.wait({
      operation: operation.name,
      project: projectId,
      zone: operation.zone.split('/').pop(),
    });
  }

  console.log('Instance deleted.');
}

deleteInstance();

PHP

use Google\Cloud\Compute\V1\Client\InstancesClient;
use Google\Cloud\Compute\V1\DeleteInstanceRequest;

/**
 * Delete an instance.
 *
 * @param string $projectId Your Google Cloud project ID.
 * @param string $zone Zone where the instance you want to delete is (like "us-central1-a").
 * @param string $instanceName Unique name for the Compute instance to delete.
 *
 * @throws \Google\ApiCore\ApiException if the remote call fails.
 * @throws \Google\ApiCore\ValidationException if local error occurs before remote call.
 */
function delete_instance(
    string $projectId,
    string $zone,
    string $instanceName
) {
    // Delete the Compute Engine instance using InstancesClient.
    $instancesClient = new InstancesClient();
    $request = (new DeleteInstanceRequest())
        ->setInstance($instanceName)
        ->setProject($projectId)
        ->setZone($zone);
    $operation = $instancesClient->delete($request);

    // Wait for the operation to complete.
    $operation->pollUntilComplete();
    if ($operation->operationSucceeded()) {
        printf('Deleted instance %s' . PHP_EOL, $instanceName);
    } else {
        $error = $operation->getError();
        printf('Failed to delete instance: %s' . PHP_EOL, $error?->getMessage());
    }
}

Python

from __future__ import annotations

import sys
from typing import Any

from google.api_core.extended_operation import ExtendedOperation
from google.cloud import compute_v1


def wait_for_extended_operation(
    operation: ExtendedOperation, verbose_name: str = "operation", timeout: int = 300
) -> Any:
    """
    Waits for the extended (long-running) operation to complete.

    If the operation is successful, it will return its result.
    If the operation ends with an error, an exception will be raised.
    If there were any warnings during the execution of the operation
    they will be printed to sys.stderr.

    Args:
        operation: a long-running operation you want to wait on.
        verbose_name: (optional) a more verbose name of the operation,
            used only during error and warning reporting.
        timeout: how long (in seconds) to wait for operation to finish.
            If None, wait indefinitely.

    Returns:
        Whatever the operation.result() returns.

    Raises:
        This method will raise the exception received from `operation.exception()`
        or RuntimeError if there is no exception set, but there is an `error_code`
        set for the `operation`.

        In case of an operation taking longer than `timeout` seconds to complete,
        a `concurrent.futures.TimeoutError` will be raised.
    """
    result = operation.result(timeout=timeout)

    if operation.error_code:
        print(
            f"Error during {verbose_name}: [Code: {operation.error_code}]: {operation.error_message}",
            file=sys.stderr,
            flush=True,
        )
        print(f"Operation ID: {operation.name}", file=sys.stderr, flush=True)
        raise operation.exception() or RuntimeError(operation.error_message)

    if operation.warnings:
        print(f"Warnings during {verbose_name}:\n", file=sys.stderr, flush=True)
        for warning in operation.warnings:
            print(f" - {warning.code}: {warning.message}", file=sys.stderr, flush=True)

    return result


def delete_instance(project_id: str, zone: str, machine_name: str) -> None:
    """
    Send an instance deletion request to the Compute Engine API and wait for it to complete.

    Args:
        project_id: project ID or project number of the Cloud project you want to use.
        zone: name of the zone you want to use. For example: “us-west3-b”
        machine_name: name of the machine you want to delete.
    """
    instance_client = compcompute_v1tInstancesClient    print(f"Deleting {machine_name} from {zone}...")
    operation = instinstance_client.delete      project=project_id, zone=zone, instance=machine_name
    )
    wait_for_extended_operation(operation, "instance deletion")
    print(f"Instance {machine_name} deleted.")

Ruby


require "google/cloud/compute/v1"

# Sends an instance deletion request to the Compute Engine API and waits for it to complete.
#
# @param [String] project project ID or project number of the Cloud project you want to use.
# @param [String] zone name of the zone you want to use. For example: "us-west3-b"
# @param [String] instance_name name of the instance you want to delete.
def delete_instance project:, zone:, instance_name:
  # Initialize client that will be used to send requests. This client only needs to be created
  # once, and can be reused for multiple requests.
  client = ::Google::Cloud::Compute::V1::Instances::Rest::Client.new

  puts "Deleting #{instance_name} from #{zone}..."
  begin
    # Make the request to delete a VM instance.
    operation = client.delete project: project, zone: zone, instance: instance_name
    # Wait for the delete operation to complete.
    operation = wait_until_done operation: operation

    compute_operation = operation.operation
    if operation.error?
      warn "Error during deletion:", compute_operation.error.errors.map { |e| "#{e.code}: #{e.message}" }
    else
      warn "Warning during deletion:", compute_operation.warnings unless compute_operation.warnings.empty?
      puts "Instance #{instance_name} deleted."
    end
  rescue ::Google::Cloud::Error => e
    warn "Exception during deletion:", e
  end
end

REST

To delete a compute instance, make a DELETE request to the instances delete method:

DELETE https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/INSTANCE_NAME

Replace the following:

  • PROJECT_ID: the ID of the project where the compute instance exists.

  • ZONE: the zone where the compute instance exists.

  • INSTANCE_NAME: the name of the compute instance.

If you want to skip or end an ongoing graceful shutdown, then include the noGracefulShutdown query parameter set to true in the request URL:

DELETE https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/VM_NAME?noGracefulShutdown=true

Delete compute instances and preserve disks

By default, deleting a compute instance deletes the compute instance and its attached resources. However, when you delete a compute instance by using the gcloud CLI, you can specify to preserve the attached disks, regardless of their auto-delete settings.

To delete one or more compute instances in the same zone while preserving their attached disks, use the gcloud compute instances delete command with the --keep-disks flag:

gcloud compute instances delete INSTANCE_NAMES \
    --keep-disks=KEEP_DISK_TYPE \
    --zone=ZONE

Replace the following:

  • INSTANCE_NAMES: a list of names of compute instances that you want to delete, separated by spaces. For example, specify instance-01 instance-02 instance-03.

  • KEEP_DISK_TYPE: the types of disks that you want to preserve. Specify one of the following values:

    • To preserve attached boot and non-boot persistent storage: all

    • To preserve only attached boot persistent storage: boot

    • To preserve only attached non-boot persistent storage: data

  • ZONE: the zone where the compute instances exist.

If you've enabled graceful shutdown in one or more compute instances, then you can save costs by deleting the compute instances without gracefully shutting them down, or by manually ending an ongoing graceful shutdown. To do so, include the --no-graceful-shutdown flag in the command:

gcloud compute instances delete VM_NAMES \
    --keep-disks=KEEP_DISK_TYPE \
    --no-graceful-shutdown \
    --zone=ZONE

What's next